#include "stdafx.h"

const int num_blobs = 3;

int blob_px[num_blobs] = {0,40,80};
int blob_py[num_blobs] = {0,49,0};
int blob_dx[num_blobs] = {8,3,-8};
int blob_dy[num_blobs] = {5,-6,3};

int vy[num_blobs][50];
int vx[num_blobs][80];



bool blobs_init() {
	return true;
}



bool blobs_shut_down() {
	return true;
}





void blobs_draw_frame(int time) {

	for (int i=0; i<num_blobs; ++i) {
		vx[i][0]=blob_px[i]/512*blob_px[i]/512;
		vy[i][0]=blob_py[i]/512*blob_py[i]/512;
		for (int x=0; x<80; ++x) {
			vx[i][x] = (blob_px[i]/512-x)*(blob_px[i]/512-x);
		}
		for (int y=0; y<50; ++y) {
			vy[i][y] = (blob_py[i]/512-y)*(blob_py[i]/512-y);
		}
	}


	CHAR_INFO *t = console_buffer;
	for (int y=0; y<50; ++y) {
		for (int x=0; x<80; ++x) {
			DWORD64 m = 1;
			for (int i=0; i<num_blobs; ++i) {
				m *= (vy[i][y] + vx[i][x]);
			}	
			int h = (int)(255-((int)(m>>20)));
			*t++ = palette[quick_find_closest_colour(0, h+x, (x+h+y)/2)];
		}

	}


	for (int i=0; i<num_blobs; ++i) {
		blob_px[i]+=blob_dx[i]*time*4;
		blob_py[i]+=blob_dy[i]*time*4;
		if (blob_px[i]<0) blob_dx[i]=2+(rand()%10);
		if (blob_px[i]>512*80) blob_dx[i]=-(2+rand()%10);
			
		if (blob_py[i]<0) blob_dy[i]=2+(rand()%10);
		if (blob_py[i]>512*50) blob_dy[i]=-(2+rand()%10);

	}
}