#include "stdafx.h"

int smeary_line_x = -1;
int smeary_line_d = 0;

int v_hold_y = 0;
int v_hold_d = 0;


void invert(int time) {
	CHAR_INFO *t = console_buffer;
	for (int i=0; i<80*50; ++i) {
		int colour = rgb_map[get_palette_from_char_info(*t)];
		int i_b = 255-(colour&0xFF); colour>>=8;
		int i_g = 255-(colour&0xFF); colour>>=8;
		int i_r = 255-(colour&0xFF);
		*t++ =  palette[quick_rgb_map[
			((i_b&0xF0)>>4)|
			((i_g&0xF0)>>0)|
			((i_r&0xF0)<<4)
		]];
	}
}

void greyscale() {
	CHAR_INFO *t = console_buffer;
	for (int i=0; i<80*50; ++i) {
		int colour = rgb_map[get_palette_from_char_info(*t)];
		int i_b = (colour&0xFF); colour>>=8;
		int i_g = (colour&0xFF); colour>>=8;
		int i_r = (colour&0xFF);
		colour = ((i_b+i_g+i_r)/3)&0xF0;
		*t++ =  palette[quick_rgb_map[
			(colour>>4)|
			(colour>>0)|
			(colour<<4)
		]];
	}
}

void black_and_white_film(int time) {

	if (smeary_line_d<=0) {
		if (smeary_line_x==-1) {
			smeary_line_x = rand()%80;
		} else {
			smeary_line_x = -1;
		}
        smeary_line_d = rand()%512;
	} else {
		smeary_line_d-=time;
	}

	if (v_hold_d<=0) {
		v_hold_y = 5-rand()%10;
		v_hold_d = rand()%128;
		if (!v_hold_y) {
			v_hold_d+=1500;
		}
	} else {
		v_hold_d-=time;
	}


	greyscale();

	if (v_hold_y) {

		if (v_hold_y<0) {
			CHAR_INFO *scroll_d = console_buffer;
			CHAR_INFO *scroll_s = console_buffer-80*v_hold_y;
			for (int f=0; f<80*(50+v_hold_y); ++f) {
				*scroll_d++=*scroll_s++;
			}
			
			for (int f=0; f<80*-v_hold_y; ++f) {
				(*scroll_d++).Attributes = 0;
			}
		} else {
			CHAR_INFO *scroll_d = console_buffer+80*50-1;
			CHAR_INFO *scroll_s = scroll_d-80*v_hold_y;
			for (int f=0; f<80*(50-v_hold_y); ++f) {
				*scroll_d--=*scroll_s--;
			}
			
			for (int f=0; f<80*v_hold_y; ++f) {
				(*scroll_d--).Attributes=0;
			}			
		}

	}

	for (int f=0; f<rand()%512; ++f) {
		console_buffer[rand()%(80*50)].Attributes = 0;
	}

	
	if (smeary_line_x>=0 && smeary_line_x<80) {
		CHAR_INFO *t = console_buffer+smeary_line_x;
		for (int y=0; y<50; ++y) {
			(*t).Attributes = 0;
			t+=80;
		}
	}
}